Name:		oswatcher
Version:	9.0.0
Release:        5%{?dist}
Summary:	OSWatcher - monitor operating system statistics

License:	GPLv2+
Source0:	oswatcher-%{version}.tar.gz
Source1:	COPYING
Source2:	oswatcher.service
Source3:	oswatcher.cfg
Source4:	oswatcher.logrotate
Patch0:		linux-friendly_ol8.patch
Patch1:		no-heartbeat.patch
Patch2:		chg-working-dir.patch
Patch3:		cfg-update.patch
Patch4:		bug33225730_vulnerability.patch
BuildArch:	noarch
BuildRequires:  systemd
Requires(post):   systemd-units
Requires(preun):  systemd-units
Requires(postun): systemd-units
# ps, vmstat, top
Requires: procps
# iostat
Requires: sysstat
# ifconfig
Requires: net-tools
# note that xentop is optional and will be installed on machines where
# it is useful anyway

%description
OSWatcher (oswbb) is a collection of UNIX shell scripts intended to
collect and archive operating system and network metrics to aid
support in diagnosing performance issues. OSWatcher operates as a set
of background processes on the server and gathers OS data on a regular
basis, invoking such Unix utilities as vmstat, netstat and iostat.

%prep
%setup -q
%patch0 -p1 -E
%patch1 -p1 -E
%patch2 -p1 -E
cp %{SOURCE3} .
%patch3 -p1 -E
cp %{SOURCE1} .
%patch4 -p1 -E

%build
sed -i \
    -e 's|@@libexec@@|%{_libexecdir}/oswatcher|g' \
    OSWatcher.sh

%install
rm -rf $RPM_BUILD_ROOT
files="arpsub.sh buddysub.sh genprvnet.sh ifconfigsub.sh
       iosub.sh mpsub.sh nfssub.sh numasub.sh oswib.sh oswnet.sh oswrds.sh
       oswsub.sh pagesub.sh pidsub.sh psmemsub.sh sarsub.sh topaix.sh
       vmsub.sh xensub.sh xtop.sh zonesub.sh"
install -m 0755 -d $RPM_BUILD_ROOT%{_libexecdir}/oswatcher
for f in $files; do
    install -m 0755 $f $RPM_BUILD_ROOT%{_libexecdir}/oswatcher/${f%.sh}
done

mkdir -p $RPM_BUILD_ROOT{%{_sbindir},%{_initddir},%{_sysconfdir}/{sysconfig,logrotate.d},%{_unitdir}}
install -m 0755 OSWatcher.sh $RPM_BUILD_ROOT%{_sbindir}/OSWatcher
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_unitdir}/oswatcher.service
install -m 0644 oswatcher.cfg $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/oswatcher
install -m 0644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/oswatcher

%post
if [ $1 -eq 1 ] ; then
	# Initial installation
	# Enabled by default
	/bin/systemctl enable oswatcher.service >/dev/null 2>&1 || :
elif [ $1 -eq 2 ]; then
	# Upgrade. 
	/bin/systemctl is-enabled oswatcher.service >/dev/null 2>&1 &&
	/bin/systemctl reenable oswatcher.service >/dev/null 2>&1 || :
fi
/bin/systemctl daemon-reload > /dev/null 2>&1 || :

%preun
%systemd_preun oswatcher.service

%postun
%systemd_postun_with_restart oswatcher.service

%files
%defattr(-,root,root,-)
%doc docs/OSWatcher/* Example_extras.txt Exampleprivate.net call_du.sh call_sar.sh call_uptime.sh COPYING
%{_sbindir}/*
%dir %{_libexecdir}/oswatcher
%{_libexecdir}/*
%ghost %config(noreplace,missingok) %attr(755,root,root) %{_libexecdir}/oswatcher/private.net
%{_unitdir}/oswatcher.service
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sysconfig/oswatcher
%{_sysconfdir}/logrotate.d/oswatcher


%changelog
* Wed Sep 08 2021 Jeffery Yoder <jeffery.yoder@oracle.com> - 9.0.0-5
- Use static path configuration for oswatcher scripts {CVE-2021-2464} [Orabug: 33225730]

* Thu Sep 17 2020 Cesar Roque <cesar.roque@oracle.com> - 9.0.0-1
- Update to oswatcher 9.0.0-1 [Orabug: 31902783]
- Fix scripts paths on OSWatcher.sh to match the oswatcher9 paths [Orabug: 31902805]

* Mon Jun 12 2020 Cesar Roque <cesar.roque@oracle.com> - 8.3.0-5
- Initial OL8 version [Orabug: 30357804]
- Fix for potential tmp directory removal [Orabug: 30754201]
- Fix for extra scripts not running [Orabug: 31030490]

* Thu Jan 30 2020 Sushmita Bhattacharya <sushmita.bhattacharya@oracle.com> - 8.3.0-4
- Update default config parameters for oswatcher. Also daemon-reload after install [Orabug: 30823577]

* Thu Jan 9 2020 Sushmita Bhattacharya <sushmita.bhattacharya@oracle.com> - 8.3.0-3
- update default config parameters for oswatcher [Orabug: 30662452]

* Wed Jan 08 2020 Sushmita Bhattacharya <sushmita.bhattacharya@oracle.com> - 8.3.0-2
- add systemd unit file [Orabug: 30581417]

* Thu Aug 8 2019 Carl Davis <carl.davis@oracle.com> - 8.3.0-1
- nfsiostat replaces nfsiostat-sysstat
- add arp collection for RAC only

* Mon May 13 2019 Carl Davis <carl.davis@oracle.com> - 8.2.0
- nfsiostat-sysstat replaces iostat -n (Linux only)
- pidstat added (Linux only)
- pidstat -d added (active process i/o) (Linux only)
- ip and ss replaces netstat(Linux only)
- ip -s -s addr replaces ifconfig -a (Linux only)
- corrected physical cpu config (Linux only)
- add xentop (Linux only)

* Thu Mar 07 2019 Gayatri Vasudevan <gayatri.vasudevan@oracle.com> - 7.3.3-5.el7
- Revert changes that use ip instead of ifconfig [Orabug: 29456699]

* Wed Feb 20 2019 Gayatri Vasudevan <gayatri.vasudevan@oracle.com> - 7.3.3-3.el7
- oswatcher: build/release 7.3.3-3 on OL7 [Orabug: 29362547]

* Wed Dec 13 2017 Herbert van den Bergh <herbert.van.den.bergh@oracle.com>
- Replace inefficient ifconfig and netstat commands with ip commands. [Orabug: 27264234]

* Tue Dec 12 2017 Carl Davis <carl.davis@oracle.com> - 8.1.2
- fix bug with high SSH connections

* Tue May 16 2017 Carl Davis <carl.davis@oracle.com> - 8.1.0
- fix bug with auto traceroute config for RAC

* Fri Apr 21 2017 Carl Davis <carl.davis@oracle.com> - 8.0.0
- Add OSWatcherFM.sh

* Wed Jan 13 2016 John Haxby <john.haxby@oracle.com>
- Refactor option parsing to make it work with recent initscripts. [Orabug: 22526481]

* Wed Dec 23 2015 John Haxby <john.haxby@oracle.com> - 7.3.3-1.el7
- Initial OL7 version

* Fri Jul 24 2015 john.haxby@oracle.com
- Initial release
